#pragma once

#include "TPref.h"
#include "TBladeEncoder.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace AudioFixLite {

	/// <summary>
	/// FormSimpleLameSetupDlg ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class FormSimpleLameSetupDlg : public System::Windows::Forms::Form
	{
	public:
		FormSimpleLameSetupDlg(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
			Font = Prefs::data->GetDialogFont();
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~FormSimpleLameSetupDlg()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::ComboBox^  cbBitrate;

	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::ComboBox^  cbMode;
	private: System::Windows::Forms::Button^  btnOK;
	private: System::Windows::Forms::Button^  btnCancel;



	protected: 

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(FormSimpleLameSetupDlg::typeid));
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->cbBitrate = (gcnew System::Windows::Forms::ComboBox());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->cbMode = (gcnew System::Windows::Forms::ComboBox());
			this->btnOK = (gcnew System::Windows::Forms::Button());
			this->btnCancel = (gcnew System::Windows::Forms::Button());
			this->SuspendLayout();
			// 
			// label1
			// 
			resources->ApplyResources(this->label1, L"label1");
			this->label1->Name = L"label1";
			// 
			// cbBitrate
			// 
			this->cbBitrate->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbBitrate->FormattingEnabled = true;
			resources->ApplyResources(this->cbBitrate, L"cbBitrate");
			this->cbBitrate->Name = L"cbBitrate";
			// 
			// label2
			// 
			resources->ApplyResources(this->label2, L"label2");
			this->label2->Name = L"label2";
			// 
			// cbMode
			// 
			this->cbMode->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbMode->FormattingEnabled = true;
			resources->ApplyResources(this->cbMode, L"cbMode");
			this->cbMode->Name = L"cbMode";
			// 
			// btnOK
			// 
			this->btnOK->DialogResult = System::Windows::Forms::DialogResult::OK;
			resources->ApplyResources(this->btnOK, L"btnOK");
			this->btnOK->Name = L"btnOK";
			this->btnOK->UseVisualStyleBackColor = true;
			this->btnOK->Click += gcnew System::EventHandler(this, &FormSimpleLameSetupDlg::btnOK_Click);
			// 
			// btnCancel
			// 
			this->btnCancel->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			resources->ApplyResources(this->btnCancel, L"btnCancel");
			this->btnCancel->Name = L"btnCancel";
			this->btnCancel->UseVisualStyleBackColor = true;
			// 
			// FormSimpleLameSetupDlg
			// 
			this->AcceptButton = this->btnOK;
			resources->ApplyResources(this, L"$this");
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->CancelButton = this->btnCancel;
			this->Controls->Add(this->btnCancel);
			this->Controls->Add(this->btnOK);
			this->Controls->Add(this->cbMode);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->cbBitrate);
			this->Controls->Add(this->label1);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"FormSimpleLameSetupDlg";
			this->ShowIcon = false;
			this->ShowInTaskbar = false;
			this->Load += gcnew System::EventHandler(this, &FormSimpleLameSetupDlg::FormSimpleLameSetupDlg_Load);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	public:
		BE_CONFIG *m_beConfig;
		BladeSetupValueTables *m_valueTables;
	private: 
		void SetupCbx(ComboBox^ cbx, std::vector<TValueTable> *table);
		void SetCbxValue(ComboBox^ cbx, std::vector<TValueTable> *table, int value);
		void SetCbxValue(ComboBox^ cbx, int value);
		int GetCbxValue(ComboBox^ cbx, std::vector<TValueTable> *table);
		int GetCbxValue(String^ valueStr, std::vector<TValueTable> *table);
		int GetCbxValue(ComboBox^ cbx);
		private: System::Void FormSimpleLameSetupDlg_Load(System::Object^  sender, System::EventArgs^  e);
		private: System::Void btnOK_Click(System::Object^  sender, System::EventArgs^  e);
	};
}
