#ifndef _TDCOFFSETFILETR_H_
#define _TDCOFFSETFILETR_H_

#pragma managed(push, off)

class TDCOffsetFilter;

class TDCOffsetFilter {
protected:
	double m_dbLeft;
	bool m_bLeftDown;
	double m_dbRight;
	bool m_bRightDown;
	int m_bits;
	double m_maxLogicalValue;
	double m_minLogicalValue;
	double m_maxLogicalDecibel;
	long m_sampleLeft;
	long m_sampleRight;
	void Init();
	void Setup(int bits, double dbLeft = 0.0, bool bLeftDown = true, double dbRight = 0.0, bool bRightDown = true);
public:
	TDCOffsetFilter();
	TDCOffsetFilter(int bits, double dbLeft = 0.0, bool bLeftDown = true, double dbRight = 0.0, bool bRightDown = true);
	long ChangeDCOffset(int ch, long inData);
};

#pragma managed(pop)

#endif
