#ifndef _TGAINFILTER_H_
#define _TGAINFILTER_H_

#pragma managed(push, off)

class TGainFilter;

class TGainFilter {
protected:
	double m_db;
	double m_magnif;
	double m_maxLogicalValue;
	double m_minLogicalValue;
	double m_maxLogicalDecibel;
	int m_bits;
public:
	void Init();
	TGainFilter();
	TGainFilter(int bits, double db = 0.0);
	double Setup(int bits, double db = 0.0);
	double SampleToDecibel(long x);
	double ChangeGainDouble(double inData);
	long ChangeGainLong(long inData);
	double CalcGainMagnif(double db);
	static double MonoDouble(double inData1, double inData2);
	static long MonoLong(long inData1, long inData2);
};

#pragma managed(pop)

#endif
