#ifndef _TWAVEFILEWRITER_H_
#define _TWAVEFILEWRITER_H_

#pragma managed(push, off)

class TWaveFileWriter {
	HMMIO m_hmmio;
	short m_sampleBits;
	short m_sampleBytes;
	size_t m_count;
	BYTE *m_buffer;
	//"WAVE"`N
	MMCKINFO m_ckWave;
	//"data"`N
	MMCKINFO m_ckData;
	void Init();
public:
	TWaveFileWriter();
	~TWaveFileWriter();
	bool Create(const std::wstring &filePath, PCMWAVEFORMAT *waveFormat, size_t dataBytes);
	bool Write(long data);
	bool Flush();
	void Close();
};

#pragma managed(pop)

#endif
